Description

When syncing yum content from upstream ULN servers, a different type of pulp_rpm remote must be used. The different remote

types can be identified via their href's as follows:

```

/pulp/api/v3/remotes/rpm/rpm/...

/pulp/api/v3/remotes/rpm/uln/...

```

When updating a remote in a way that requires switching the remote type between uln and normal, Katello does not currently do so,

and Pulp will not throw an error. The result will be a uln remote with data for a normal rpm sync, or vice versa. This will result in failed

syncs.

Example reproducer workflow:

1. Create a yum type repo with any repo URL, e.g.: `https://fixtures.pulpproject.org/rpm-signed/`   * Check to see that the Katello

repository created references a remote href beginning with `/pulp/api/v3/remotes/rpm/rpm/...`

2. Now switch the URL to for example `uln://ol8_x86_64_oracle_instantclient` (you will also need to set login credentials but just

set anything, we don't actually need to sync to see the problem)   * Check the Katello repo again. It will still use the exact same

rpm remote as before.

3. Check the pulp_rpm remote with `pulp show --href <remote_href>`.   * You will see that the rpm (not uln) type remote now has

`"url": "uln://ol8_x86_64_oracle_instantclient"`. This cannot work for syncing!

PR to follow shortly.

Associated revisions

Revision 97f8a09c - 05/07/2024 05:59 PM - Quirin Pamp

Fixes #37279 - Re-create remotes when the type needs to change

When updating a remote, we need to re-create it instead if the type has

changed from uln to rpm or vice versa.

For operations on a remote href, the type is now determined from the

href, rather than indirectly from the url. This is more robust since it

is the actually relevant source of truth. In addition the remote API

selection code is now deduplicated within the new get_remote_api method.

History

#1 - 03/19/2024 01:25 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/Katello/katello/pull/10942 added
#2 - 03/20/2024 05:43 PM - Samir Jha

- Target version set to Katello 4.13.0

- Triaged changed from No to Yes

#3 - 04/26/2024 09:28 AM - Quirin Pamp

Note: I also created a pulp_rpm issue, to have Pulp add validation that throws a meaningful error at remote creation time, rather than a cryptic one at

sync time, should we ever get this wrong again in the future: https://github.com/pulp/pulp_rpm/issues/3520

#4 - 05/07/2024 05:59 PM - The Foreman Bot

- Fixed in Releases Katello 4.13.0 added

#5 - 05/07/2024 06:00 PM - Quirin Pamp

- Status changed from Ready For Testing to Closed

Applied in changeset katello|97f8a09c3338b702c1d2735318e8c5e3b1b6b953.
